Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.Designer.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.Designer.cs	(revision 14897)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.Designer.cs	(revision 14897)
@@ -0,0 +1,198 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Views {
+  using System.ComponentModel;
+  using System.Drawing;
+  using System.Windows.Forms;
+
+  partial class PushDebuggerView {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (this.components != null)) {
+        this.components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(PushDebuggerView));
+      this.execGroupBox = new System.Windows.Forms.GroupBox();
+      this.execList = new System.Windows.Forms.ListBox();
+      this.debugTableLayout = new System.Windows.Forms.TableLayoutPanel();
+      this.stepButton = new System.Windows.Forms.Button();
+      this.resetButton = new System.Windows.Forms.Button();
+      this.stepWidthBox = new System.Windows.Forms.NumericUpDown();
+      this.runButton = new System.Windows.Forms.Button();
+      this.skipNoopsCheckBox = new System.Windows.Forms.CheckBox();
+      this.simplifyButton = new System.Windows.Forms.Button();
+      this.execGroupBox.SuspendLayout();
+      this.debugTableLayout.SuspendLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.stepWidthBox)).BeginInit();
+      this.SuspendLayout();
+      //
+      // execGroupBox
+      //
+      this.execGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.execGroupBox.AutoSize = true;
+      this.execGroupBox.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
+      this.execGroupBox.Controls.Add(this.execList);
+      this.execGroupBox.Location = new System.Drawing.Point(3, 3);
+      this.execGroupBox.Name = "execGroupBox";
+      this.execGroupBox.Size = new System.Drawing.Size(244, 460);
+      this.execGroupBox.TabIndex = 3;
+      this.execGroupBox.TabStop = false;
+      this.execGroupBox.Text = "Exec";
+      //
+      // execList
+      //
+      this.execList.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.execList.FormattingEnabled = true;
+      this.execList.Location = new System.Drawing.Point(3, 16);
+      this.execList.Name = "execList";
+      this.execList.Size = new System.Drawing.Size(238, 441);
+      this.execList.TabIndex = 0;
+      //
+      // debugTableLayout
+      //
+      this.debugTableLayout.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.debugTableLayout.AutoScroll = true;
+      this.debugTableLayout.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
+      this.debugTableLayout.ColumnCount = 2;
+      this.debugTableLayout.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 250F));
+      this.debugTableLayout.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
+      this.debugTableLayout.Controls.Add(this.execGroupBox, 0, 0);
+      this.debugTableLayout.Location = new System.Drawing.Point(3, 3);
+      this.debugTableLayout.Name = "debugTableLayout";
+      this.debugTableLayout.RowCount = 1;
+      this.debugTableLayout.RowStyles.Add(new System.Windows.Forms.RowStyle());
+      this.debugTableLayout.Size = new System.Drawing.Size(872, 466);
+      this.debugTableLayout.TabIndex = 18;
+      //
+      // stepButton
+      //
+      this.stepButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.stepButton.Image = ((System.Drawing.Image)(resources.GetObject("stepButton.Image")));
+      this.stepButton.Location = new System.Drawing.Point(109, 475);
+      this.stepButton.Name = "stepButton";
+      this.stepButton.Size = new System.Drawing.Size(28, 26);
+      this.stepButton.TabIndex = 22;
+      this.stepButton.UseVisualStyleBackColor = true;
+      //
+      // resetButton
+      //
+      this.resetButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.resetButton.Image = ((System.Drawing.Image)(resources.GetObject("resetButton.Image")));
+      this.resetButton.Location = new System.Drawing.Point(3, 475);
+      this.resetButton.Name = "resetButton";
+      this.resetButton.Size = new System.Drawing.Size(28, 26);
+      this.resetButton.TabIndex = 23;
+      this.resetButton.UseVisualStyleBackColor = true;
+      //
+      // stepWidthBox
+      //
+      this.stepWidthBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.stepWidthBox.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+      this.stepWidthBox.Location = new System.Drawing.Point(70, 476);
+      this.stepWidthBox.Maximum = new decimal(new int[] {
+            99999,
+            0,
+            0,
+            0});
+      this.stepWidthBox.Minimum = new decimal(new int[] {
+            1,
+            0,
+            0,
+            0});
+      this.stepWidthBox.Name = "stepWidthBox";
+      this.stepWidthBox.Size = new System.Drawing.Size(40, 24);
+      this.stepWidthBox.TabIndex = 21;
+      this.stepWidthBox.Value = new decimal(new int[] {
+            1,
+            0,
+            0,
+            0});
+      //
+      // runButton
+      //
+      this.runButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.runButton.Image = ((System.Drawing.Image)(resources.GetObject("runButton.Image")));
+      this.runButton.Location = new System.Drawing.Point(37, 475);
+      this.runButton.Name = "runButton";
+      this.runButton.Size = new System.Drawing.Size(28, 26);
+      this.runButton.TabIndex = 24;
+      this.runButton.UseVisualStyleBackColor = true;
+      //
+      // skipNoopsCheckBox
+      //
+      this.skipNoopsCheckBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.skipNoopsCheckBox.AutoSize = true;
+      this.skipNoopsCheckBox.Checked = true;
+      this.skipNoopsCheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
+      this.skipNoopsCheckBox.Location = new System.Drawing.Point(147, 481);
+      this.skipNoopsCheckBox.Name = "skipNoopsCheckBox";
+      this.skipNoopsCheckBox.Size = new System.Drawing.Size(81, 17);
+      this.skipNoopsCheckBox.TabIndex = 25;
+      this.skipNoopsCheckBox.Text = "Skip NOOP";
+      this.skipNoopsCheckBox.UseVisualStyleBackColor = true;
+      //
+      // simplifyButton
+      //
+      this.simplifyButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.simplifyButton.Location = new System.Drawing.Point(813, 475);
+      this.simplifyButton.Name = "simplifyButton";
+      this.simplifyButton.Size = new System.Drawing.Size(62, 26);
+      this.simplifyButton.TabIndex = 26;
+      this.simplifyButton.Text = "Simplify";
+      this.simplifyButton.UseVisualStyleBackColor = true;
+      //
+      // PushDebuggerView
+      //
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.simplifyButton);
+      this.Controls.Add(this.skipNoopsCheckBox);
+      this.Controls.Add(this.runButton);
+      this.Controls.Add(this.stepWidthBox);
+      this.Controls.Add(this.resetButton);
+      this.Controls.Add(this.stepButton);
+      this.Controls.Add(this.debugTableLayout);
+      this.Name = "PushDebuggerView";
+      this.Size = new System.Drawing.Size(878, 504);
+      this.execGroupBox.ResumeLayout(false);
+      this.debugTableLayout.ResumeLayout(false);
+      this.debugTableLayout.PerformLayout();
+      ((System.ComponentModel.ISupportInitialize)(this.stepWidthBox)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private GroupBox execGroupBox;
+    private ListBox execList;
+    private TableLayoutPanel debugTableLayout;
+    private Button stepButton;
+    private Button resetButton;
+    private NumericUpDown stepWidthBox;
+    private Button runButton;
+    private CheckBox skipNoopsCheckBox;
+    private Button simplifyButton;
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs	(revision 14897)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Views/PushDebuggerView.cs	(revision 14897)
@@ -0,0 +1,281 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Views {
+  using Configuration;
+  using Core.Views;
+  using Expressions;
+  using Interpreter;
+  using MainForm;
+  using Problem;
+  using Stack;
+
+  public partial class PushDebuggerView : ItemView {
+    private readonly IDictionary<StackTypes, ListBox> debugControlDict = new Dictionary<StackTypes, ListBox>();
+
+    private PooledPushInterpreter interpreter;
+    private PooledPushInterpreter interpreter2; // used to determine noops
+    private PushInterpreterPool pool;
+
+    private const string GroupBoxTextStringFormat = "{0}[{1}]";
+
+    public event EventHandler<IPushInterpreter> OnReset;
+
+    public PushDebuggerView() {
+      InitializeComponent();
+      InitEvents();
+    }
+
+    ~PushDebuggerView() {
+      interpreter.Dispose();
+      interpreter2.Dispose();
+    }
+
+    public new PushSolution Content
+    {
+      get { return (PushSolution)base.Content; }
+      set
+      {
+        base.Content = value;
+      }
+    }
+
+    protected override void OnContentChanged() {
+      if (Content == null) return;
+
+      Name = "Push Debugger";
+      pool = new PushInterpreterPool(Content.Config);
+
+      if (interpreter != null) {
+        interpreter.Dispose();
+        interpreter2.Dispose();
+      }
+
+      interpreter = pool.Create(Content.Random);
+      interpreter2 = pool.Create(Content.Random);
+
+
+      InitDebugLists(Content.Config);
+      ClearDebugLists();
+      UpdateExecList();
+      UpdateDebugLists();
+      ResetDebugging();
+    }
+
+    private void InitEvents() {
+      runButton.Click += RunButtonClick;
+      resetButton.Click += ResetButtonClick;
+      stepButton.Click += StepButtonClick;
+      simplifyButton.Click += SimplifyButtonClick;
+    }
+
+    private void RunButtonClick(object sender, EventArgs e) {
+      if (interpreter == null)
+        return;
+
+      interpreter.Resume();
+
+      ResetDebugging();
+      UpdateExecList();
+      UpdateDebugLists();
+      CheckIfButtonsCanBeEnabled();
+    }
+
+    private void StepButtonClick(object sender, EventArgs e) {
+      if (interpreter == null || stepWidthBox.Value <= 0)
+        return;
+
+      var count = Math.Min(stepWidthBox.Value, interpreter.ExecStack.Count);
+
+      if (!interpreter.CanStep)
+        return;
+
+      // skip leading noops
+      if (interpreter2.ExecCounter == (Content.Program.IsProgram ? 1 : 0) &&
+          skipNoopsCheckBox.Checked &&
+          SkipNoops()) {
+        count = 0; // no entries left, cause all were noops
+      }
+
+      for (var i = 0; i < count; i++) {
+        if (skipNoopsCheckBox.Checked) {
+          interpreter.Step();
+
+          if (SkipNoops())
+            break;
+        } else {
+          interpreter.Step();
+          interpreter2.Step();
+        }
+      }
+
+      stepWidthBox.Maximum = Math.Max(1, interpreter.ExecStack.Count);
+
+      UpdateExecList();
+      UpdateDebugLists();
+      CheckIfButtonsCanBeEnabled();
+    }
+
+    private bool SkipNoops() {
+      var skipCount = 0;
+      bool isNoop;
+
+      do {
+        skipCount++;
+        isNoop = !interpreter2.Step();
+      } while (interpreter2.CanStep && isNoop);
+
+      if (isNoop) {
+        interpreter.Step(skipCount);
+      } else if (skipCount > 1) {
+        interpreter.Step(skipCount - 1);
+      }
+
+      return isNoop;
+    }
+
+    private void CheckIfButtonsCanBeEnabled() {
+      runButton.Enabled = interpreter != null && interpreter.CanStep;
+      stepButton.Enabled = interpreter != null && interpreter.CanStep;
+      stepWidthBox.Enabled = interpreter != null && interpreter.CanStep;
+    }
+
+    private void ResetButtonClick(object sender, EventArgs e) {
+      ResetDebugging();
+    }
+
+    private void SimplifyButtonClick(object sender, EventArgs e) {
+      var newContent = Content.Simplify();
+
+      MainFormManager.MainForm.ShowContent(newContent, GetType());
+    }
+
+    public void ResetDebugging() {
+      if (Content == null ||
+          pool == null ||
+          Content.Program == null)
+        return;
+
+      if (interpreter != null) {
+        interpreter.Reset();
+        interpreter2.Reset();
+      }
+
+      if (OnReset != null) {
+        OnReset(this, interpreter);
+        OnReset(this, interpreter2);
+      }
+
+      interpreter.Run(Content.Program, true);
+      interpreter2.Run(Content.Program, true);
+
+      stepWidthBox.Maximum = interpreter.ExecStack.Count;
+
+      UpdateDebugLists();
+      UpdateExecList();
+      CheckIfButtonsCanBeEnabled();
+    }
+
+    private void ClearDebugLists() {
+      foreach (var list in debugControlDict.Values) {
+        list.Items.Clear();
+      }
+    }
+
+    private void UpdateExecList() {
+      execList.Items.Clear();
+      var expressions = interpreter.ExecStack.AsEnumerable()
+        .Reverse()
+        .Select(e => e.StringRepresentation)
+        .ToArray();
+
+      execList.Items.AddRange(expressions);
+      execGroupBox.Text = string.Format(GroupBoxTextStringFormat, Enum.GetName(typeof(StackTypes), StackTypes.Exec), interpreter.ExecStack.Count);
+    }
+
+    private void InitDebugLists(IReadOnlyPushConfiguration config) {
+      debugControlDict.Clear();
+
+      // 2 = ExecList + EmptyColumn which is required to fill empty space
+      while (debugTableLayout.ColumnCount > 2) {
+        debugTableLayout.Controls.RemoveAt(1);
+        debugTableLayout.ColumnCount--;
+      }
+
+      foreach (StackTypes stackType in Enum.GetValues(typeof(StackTypes))) {
+        if (stackType != StackTypes.Exec &&
+            ExpressionTable.GetExpressionsByStackTypes(stackType).Intersect(config.EnabledExpressions).Any()) {
+          var list = CreateDebugList(stackType);
+          debugControlDict.Add(stackType, list);
+        }
+      }
+    }
+
+    private ListBox CreateDebugList(StackTypes type) {
+      var groupBox = new GroupBox {
+        Anchor = AnchorStyles.Bottom | AnchorStyles.Right | AnchorStyles.Left | AnchorStyles.Top,
+        AutoSize = true,
+        AutoSizeMode = AutoSizeMode.GrowAndShrink,
+        Text = Enum.GetName(typeof(StackTypes), type)
+      };
+
+      var list = new ListBox {
+        Dock = DockStyle.Fill,
+        DrawMode = DrawMode.OwnerDrawFixed
+      };
+
+      var stackEntryType = type.GetStackEntryType();
+      if (stackEntryType == typeof(double) ||
+          stackEntryType == typeof(long)) {
+        list.DrawItem += (sender, e) => {
+          if (e.Index <= -1) return;
+          var item = list.Items[e.Index];
+
+          e.DrawBackground();
+          e.DrawFocusRectangle();
+
+          var brush = new SolidBrush(e.ForeColor);
+          var size = e.Graphics.MeasureString(item.ToString(), e.Font);
+
+          e.Graphics.DrawString(
+            item.ToString(),
+            e.Font,
+            brush,
+            e.Bounds.Right - size.Width,
+            e.Bounds.Top + (e.Bounds.Height / 2 - size.Height / 2));
+        };
+      }
+
+      groupBox.Controls.Add(list);
+
+      var columnWidth = stackEntryType == typeof(Expression) ? 250 : 150;
+
+      debugTableLayout.ColumnCount++;
+      debugTableLayout.ColumnStyles.Insert(1, new ColumnStyle(SizeType.Absolute, columnWidth));
+      debugTableLayout.Controls.Add(groupBox);
+      debugTableLayout.Controls.SetChildIndex(groupBox, 1);
+
+      return list;
+    }
+
+
+    private void UpdateDebugLists() {
+      ClearDebugLists();
+
+      if (Content == null || interpreter == null)
+        return;
+
+      foreach (var pair in debugControlDict) {
+        var stack = interpreter.GetStackEntriesByType<object>(pair.Key);
+        var name = Enum.GetName(typeof(StackTypes), pair.Key);
+
+        pair.Value.Items.AddRange(stack.Reverse().ToArray());
+        ((GroupBox)pair.Value.Parent).Text = string.Format(GroupBoxTextStringFormat, name, pair.Value.Items.Count);
+      }
+    }
+
+  }
+}
